module ConcurrentUtil(trySeveral) where

import Concurrent
import Exception
import List(delete)

-- concurrently try several IO actions, returning the result of the first to finish.
-- if all actions throw exceptions, one is passed on non-deterministically
trySeveral :: [IO a] -> IO a
trySeveral [] = error "trySeveral has nothing to try!"
trySeveral arms = do
    v <- newEmptyMVar 
    ts <- mapM (forkIO . f v) arms
    g v ts where
	f v arm = do
	    t <- myThreadId
	    r <- try arm
	    putMVar v (t,r)
	g v ts = do
	    (t,r) <- takeMVar v
	    let ts' = delete t ts
	    case r of 
		Left e -> do
		    if null ts' then throw e else g v ts'
		Right x -> do
		    mapM_ killThread ts'
		    return x
	    
	    
	    
